﻿Public Class Downloader

    Friend WithEvents dParentJob As DownloadJob
    Friend DownloadThreads() As Threading.Thread
    Friend DownloadSockets() As Net.Sockets.Socket
    Friend Sub StartNextThread(ByRef prevRangeJob As ThreadRangeJob) Handles dParentJob.ContinueResume
        Dim index As Int64
        If prevRangeJob Is Nothing Then
            index = 0
        Else
            index = Array.IndexOf(dParentJob.ThreadJobs, prevRangeJob) + 1
        End If
        If index = -1 Or index = dParentJob.nThreads Then Exit Sub
        DownloadThreads(index) = New Threading.Thread(AddressOf startHTTPDownload)
        DownloadThreads(index).Start(index)
    End Sub
    Friend Sub startHTTPDownload(ByVal index As Int64)
        If dParentJob.ThreadJobs(index) Is Nothing Then dParentJob.ThreadJobs(index) = New ThreadRangeJob
        Dim myLog As InfoLog = dParentJob.cItemLog(index)
        myLog.UpdateThreadStatus(InfoLog.ThreadState.Starting)
        If dParentJob.ThreadJobs(index).iEnd > 0 And dParentJob.ThreadJobs(index).iStart + dParentJob.ThreadJobs(index).iCurrent >= dParentJob.ThreadJobs(index).iEnd Then
            myLog.UpdateThreadStatus(InfoLog.ThreadState.Done)
            myLog.Update(InfoLogItem.Direction.Impo, "Thread Work Complete.")
            dParentJob.ResumeNextThread(dParentJob.ThreadJobs(index))
            Exit Sub
        End If
        If myLog Is Nothing Or myLog.dParentJob Is Nothing Then
            myLog = New InfoLog : myLog.Setup(dParentJob)
        End If
        Dim WorkCompleted As Boolean = False
        Dim mUri As Uri
        Dim mReferer As String = dParentJob.sReferer
        Dim mCookies As String = dParentJob.sCookies
        Dim downloadSocket As Net.Sockets.Socket
        Try
            mUri = New Uri(dParentJob.sDownloadURL & ":" & dParentJob.iPort)
        Catch Ex As Exception
            dParentJob.HandleException(Ex)
            myLog.Update(InfoLogItem.Direction._Error, Ex.Message)
            myLog.Update(InfoLogItem.Direction._Error, "False Uniform Resource Information (Bad link).")
            myLog.UpdateThreadStatus(InfoLog.ThreadState.Stopped)
            Exit Sub
        End Try
        Do
            downloadSocket = New Net.Sockets.Socket(Net.Sockets.AddressFamily.InterNetwork, Net.Sockets.SocketType.Stream, Net.Sockets.ProtocolType.Tcp)
            DownloadSockets(index) = downloadSocket
            If downloadSocket.TryConnect(mUri, myLog) = False Then myLog.UpdateThreadStatus(InfoLog.ThreadState.Stopped) : Exit Sub
            Dim requestHeader As String
            requestHeader = CreateHTTPRequest(mUri.OriginalString.Replace(":" & mUri.Port, ""), mReferer, "GET", "1.1", User_Agents.Internet_Explorer_6, , False, mCookies, dParentJob.ThreadJobs(index).iCurrent + dParentJob.ThreadJobs(index).iStart)
            If downloadSocket.TrySend(Enc.GetBytes(requestHeader), myLog) = False Then myLog.UpdateThreadStatus(InfoLog.ThreadState.Stopped) : Exit Sub
            Dim rHeader As String = ""
            If downloadSocket.TryHeader(rHeader, myLog) = False Then myLog.UpdateThreadStatus(InfoLog.ThreadState.Stopped) : Exit Sub
            mCookies.UpdateCookies(rHeader)
            If rHeader.FirstLine.ContainsI("30x") Then
                mReferer = mUri.OriginalString.Replace(":" & mUri.Port, "")
                Dim newLocation As String = rHeader.GetValue("Location: ")
                If newLocation = Nothing Then
                    myLog.Update(InfoLogItem.Direction._Error, "Missing location.")
                    If dParentJob.ThreadJobs(index).iStart = 0 And dParentJob.ThreadJobs(index).iCurrent > 0 Then
                        myLog.Update(InfoLogItem.Direction._Error, "You have to restart this download, or find a manual way to resume it.")
                    End If
                    myLog.UpdateThreadStatus(InfoLog.ThreadState.Stopped)
                    Exit Sub
                End If
                Try
                    mUri = New Uri(newLocation)
                Catch Ex As Exception
                    dParentJob.HandleException(Ex)
                    myLog.Update(InfoLogItem.Direction._Error, Ex.Message)
                    myLog.Update(InfoLogItem.Direction._Error, "False Uniform Resource Information (Bad link).")
                    If dParentJob.ThreadJobs(index).iStart = 0 And dParentJob.ThreadJobs(index).iCurrent > 0 Then
                        myLog.Update(InfoLogItem.Direction._Error, "You have to restart this download, or find a manual way to resume it.")
                    End If
                    myLog.UpdateThreadStatus(InfoLog.ThreadState.Stopped)
                    Exit Sub
                End Try
                myLog.Update(InfoLogItem.Direction.Impo, "Trying new url: " & newLocation)
                Continue Do
            End If
            If rHeader.FirstLine.ContainsI("206") Then dParentJob.canResume = True
            If rHeader.FirstLine.ContainsI("20") = False Then
                myLog.Update(InfoLogItem.Direction._Error, "Bad Header")
                Dim rLength As Int64 = rHeader.GetValue("Content-Length:")
                If rLength > 0 Then
                    '  dParentJob.iLength = rLength
                    '   downloadSocket.TryGetData(rLength, 0, New Boolean, dParentJob.ThreadJobs(index), myLog)
                End If
                If dParentJob.ThreadJobs(index).iStart = 0 And dParentJob.ThreadJobs(index).iCurrent > 0 Then
                    myLog.Update(InfoLogItem.Direction._Error, "You have to restart this download, or find a manual way to resume it.")
                End If
                myLog.UpdateThreadStatus(InfoLog.ThreadState.Stopped)
                Exit Sub
            End If
            If dParentJob.ThreadJobs(index).iCurrent > 0 And rHeader.FirstLine.ContainsI("206") = False Then
                myLog.Update(InfoLogItem.Direction._Error, "This site does not currently support resume.")
                If dParentJob.ThreadJobs(index).iStart = 0 Then
                    myLog.Update(InfoLogItem.Direction._Error, "You have to restart this download, or find a manual way to resume it.")
                End If
                myLog.UpdateThreadStatus(InfoLog.ThreadState.Stopped)
                Exit Sub
            End If
            If dParentJob.ThreadJobs(index).iStart > 0 And rHeader.FirstLine.ContainsI("206") = False Then
                myLog.Update(InfoLogItem.Direction._Error, "This site does not currently support resume.")
                myLog.Update(InfoLogItem.Direction._Error, "Thread aborted. Main thread will finish download.")
                dParentJob.canResume = False
                myLog.UpdateThreadStatus(InfoLog.ThreadState.Stopped)
                Exit Sub
            End If
            Dim restLength As Int64 = rHeader.GetValue("Content-Length:")
            If restLength = 0 Then
                myLog.Update(InfoLogItem.Direction.Impo, "Resume not supported!")
                If rHeader.ContainsI("Chunked") Then
                    myLog.Update(InfoLogItem.Direction.Impo, "Chunked Transfer Enconding")
                    dParentJob.isChunked = True
                    Exit Sub
                End If
            End If
            myLog.Update(InfoLogItem.Direction.Impo, "Download size: " & dParentJob.ThreadJobs(index).iStart + dParentJob.ThreadJobs(index).iCurrent + restLength)
            If dParentJob.iLength = -1 Then dParentJob.iLength = restLength
            If dParentJob.cStatBoard Is Nothing Then dParentJob.cStatBoard = New StatBoard : dParentJob.cStatBoard.Setup(dParentJob.iLength, dParentJob)
            dParentJob.MakeThreadRanges()
            If dParentJob.iLength <> dParentJob.ThreadJobs(index).iStart + dParentJob.ThreadJobs(index).iCurrent + restLength Then
                myLog.Update(InfoLogItem.Direction._Error, "The file's download size has changed. You must restart the download to continue.")
                myLog.UpdateThreadStatus(InfoLog.ThreadState.Stopped)
                Exit Sub
            End If
            dParentJob.ResumeNextThread(dParentJob.ThreadJobs(index))
            myLog.UpdateThreadStatus(InfoLog.ThreadState.Downloading)
            dParentJob.cStatBoard.Setup(dParentJob.iLength, dParentJob)
            downloadSocket.TryGetData(dParentJob.ThreadJobs(index).iEnd - (dParentJob.ThreadJobs(index).iCurrent + dParentJob.ThreadJobs(index).iStart) + 1, dParentJob.ThreadJobs(index).iCurrent + dParentJob.ThreadJobs(index).iStart, WorkCompleted, dParentJob.ThreadJobs(index), myLog)
            If WorkCompleted = False Then myLog.Update(InfoLogItem.Direction.Impo, "Thread work stopped. Retrying in " & (dParentJob.iThreadRetryTime / 1000) & " seconds.")
            Threading.Thread.Sleep(dParentJob.iThreadRetryTime)
        Loop Until WorkCompleted = True
        myLog.Update(InfoLogItem.Direction.Impo, "Thread Work Complete.")
        Dim nextIndex As Int64 = Array.IndexOf(dParentJob.ThreadJobs, dParentJob.ThreadJobs(index)) + 1
        If nextIndex < dParentJob.ThreadJobs.Length Then
            If dParentJob.ThreadJobs(nextIndex).IsBlank = True Then
                Dim Finish As Boolean = False
                myLog.Update(InfoLogItem.Direction.Impo, "Next thread hasn't started. Taking over.")
                downloadSocket.TryGetRemainingData(dParentJob.ThreadJobs(index).iEnd + 1, Finish, myLog)
                If Finish = True Then myLog.Update(InfoLogItem.Direction.Impo, "Download Complete. Restart if its not.")
                If Finish = False Then myLog.Update(InfoLogItem.Direction.Impo, "Download Ended. Might not be complete. Restart if its not.")
            End If
        End If
        myLog.UpdateThreadStatus(InfoLog.ThreadState.Done)
    End Sub
    Private Function CreateHTTPRequest(ByVal URL As String, ByVal referer As String, ByVal Method As String, ByVal Version As String, ByVal UserAgent As User_Agents, Optional ByVal Length As Int64 = -1, Optional ByVal proxy As Boolean = False, Optional ByVal cookie As String = "", Optional ByVal range As Int64 = 0) As String
        Dim Request As String
        If proxy = True Then
            Request = Method & " " & URL & " HTTP/" & Version
        Else
            Request = Method & " " & URL.URLRest & " HTTP/" & Version
        End If
        Request.AddLine("Accept: */*")
        If referer <> "" Then Request.AddLine("Referer: " & referer)
        Request.AddLine("Accept-Language: en-us")
        If range > 0 Then Request.AddLine("Range: bytes=" & range & "-")
        If Length <> -1 Then Request.AddLine("Content-Type: application/x-www-form-urlencoded")
        Request.AddLine("UA-CPU: x86")
        Request.AddLine("User-Agent: " & UserAgent.UAValue)
        Request.AddLine("Host: " & URL.URLBase)
        If Length <> -1 Then Request.AddLine("Content-Length: " & Length)
        Request.AddLine("Connection: Keep-Alive")
        'Request.AddLine("Icy-MetaData: 1")
        'Request.AddLine("Bandwidth: 104858000")
        If cookie <> "" Then Request.AddLine("Cookie: " & cookie)
        Return Request & vbCrLf & vbCrLf
    End Function

End Class
