﻿Module ErrorHandler
    Public ErrorListView As ListView
    Public ExceptionPath As String = "C:\Downloader.txt"
    Public Sub HandleException(ByVal Exc As Exception, Optional ByVal Message As Boolean = False)
        Dim ErrorLogStream As New IO.FileStream(ExceptionPath, IO.FileMode.OpenOrCreate, IO.FileAccess.ReadWrite, IO.FileShare.ReadWrite)
        ErrorLogStream.Position = ErrorLogStream.Length
        Dim txtR As String = ""
        txtR.AddLine("-----------------------------")
        txtR.AddLine("Message:" & Exc.Message)
        txtR.AddLine("Stack Trace:" & Exc.StackTrace)
        ErrorLogStream.Write(Enc.GetBytes(txtR), 0, Enc.GetByteCount(txtR))
        ErrorLogStream.Close()
        If Message = True Then
            MessageBox.Show(Exc.Message, "Error At:" & Exc.TargetSite.Name & " Line:" & Exc.StackTrace.FromXTillEnd(":line "), MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
        If Not ErrorListView Is Nothing Then
            ErrorListView.Items.Add("Time: " & DateTime.Now.TimeOfDay.ToString)
            ErrorListView.Items.Add("Message:" & Exc.Message)
            ErrorListView.Items.Add("Method:" & Exc.TargetSite.Name & " Line:" & Exc.StackTrace.FromXTillEnd(":line "))
            ErrorListView.Items.Add("Module:" & Exc.TargetSite.ReflectedType.Name)
        End If
    End Sub
    Public Sub UnhandledExceptions(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.ApplicationServices.UnhandledExceptionEventArgs)
        Dim exc As Exception = e.Exception
        Dim ErrorLogStream As New IO.FileStream(ExceptionPath, IO.FileMode.OpenOrCreate, IO.FileAccess.ReadWrite, IO.FileShare.ReadWrite)
        ErrorLogStream.Position = ErrorLogStream.Length
        Dim txtR As String = ""
        txtR.AddLine("-----------------------------")
        txtR.AddLine("Message:" & exc.Message)
        txtR.AddLine("Stack Trace:" & exc.StackTrace)
        ErrorLogStream.Write(Enc.GetBytes(txtR), 0, Enc.GetByteCount(txtR))
        ErrorLogStream.Close()
        Dim message As Boolean = False
        If message = True Then
            MessageBox.Show(exc.Message, "Error At:" & exc.TargetSite.Name & " Line:" & exc.StackTrace.FromXTillEnd(":line "), MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
        If Not ErrorListView Is Nothing Then
            ErrorListView.Items.Add("Time: " & DateTime.Now.TimeOfDay.ToString)
            ErrorListView.Items.Add("Message:" & exc.Message)
            ErrorListView.Items.Add("Method:" & exc.TargetSite.Name & " Line:" & exc.StackTrace.FromXTillEnd(":line "))
            ErrorListView.Items.Add("Module:" & exc.TargetSite.ReflectedType.Name)
        End If
    End Sub
End Module
